/* settings.js: version 1.0 */

var lw_PrefBranchPrefix = "link_wrapper."

var mySettings = {

  init: function() {
    linkWrapper_common.init();

    try {
      document.getElementById("myExtra1").setAttribute("disabled", "true");
    } catch (ex) {
    }

    var i;
    var thisTagList = "";
    var objectEnableApply = ['checkbox', 'textbox']; //'button'

    for(var o in objectEnableApply) {
      thisTagList = document.getElementsByTagName(objectEnableApply[o]);
      for (i = 0; i < thisTagList.length; i++) {
        thisTagList[i].addEventListener("click", mySettings.enableApply, true);
      }
    }

    this.getSettings();

    return true;
  },

  getSettings: function() {

    var prefService = Components.classes["@mozilla.org/preferences-service;1"].
      getService(Components.interfaces.nsIPrefService);

    var nsIPrefBranchObj = prefService.getBranch(lw_PrefBranchPrefix);

    var i;
    var thisTagList = "";
    var objectEnableApply = ['checkbox', 'textbox'];

    for(var o in objectEnableApply) {
      thisTagList = document.getElementsByTagName(objectEnableApply[o]);

      for (i = 0; i < thisTagList.length; i++) {
        switch (nsIPrefBranchObj.getPrefType(thisTagList[i].id)) {
          case nsIPrefBranchObj.PREF_STRING:  // Text = 32
            thisTagList[i].value = nsPreferences.copyUnicharPref(lw_PrefBranchPrefix + thisTagList[i].id);
            break;
          case nsIPrefBranchObj.PREF_INT:  // Integer = 64
            thisTagList[i].value = nsPreferences.getIntPref(lw_PrefBranchPrefix + thisTagList[i].id);
            break;
          case nsIPrefBranchObj.PREF_BOOL:  // Boolean =128
            thisTagList[i].checked = nsPreferences.getBoolPref(lw_PrefBranchPrefix + thisTagList[i].id);
            break;
        }
      }
    }

    return true;
  },

  acceptChanges: function() {

    try {
      document.getElementById("myExtra1").setAttribute("disabled", "true");
    } catch(ex) {
    }

    var prefService = Components.classes["@mozilla.org/preferences-service;1"].
      getService(Components.interfaces.nsIPrefService);

    var nsIPrefBranchObj = prefService.getBranch(lw_PrefBranchPrefix);

    var i;
    var thisTagList = "";
    var objectEnableApply = ['checkbox', 'textbox'];

    for(var o in objectEnableApply) {
      thisTagList = document.getElementsByTagName(objectEnableApply[o]);

      for (i = 0; i < thisTagList.length; i++) {
        switch (nsIPrefBranchObj.getPrefType(thisTagList[i].id)) {
          case nsIPrefBranchObj.PREF_STRING:  // Text = 32
            nsPreferences.setUnicharPref(lw_PrefBranchPrefix + thisTagList[i].id, thisTagList[i].value);
            break;
          case nsIPrefBranchObj.PREF_INT:  // Integer = 64
            nsPreferences.setIntPref(lw_PrefBranchPrefix + thisTagList[i].id, thisTagList[i].value);
            break;
          case nsIPrefBranchObj.PREF_BOOL:  // Boolean =128
            nsPreferences.setBoolPref(lw_PrefBranchPrefix + thisTagList[i].id, thisTagList[i].checked);
            break;
        }
      }
    }

    return true;
  },

  enableApply: function() {
    document.getElementById("myExtra1").setAttribute("disabled", "false");
  },
  
  exportData: function() {

    var prefService = Components.classes["@mozilla.org/preferences-service;1"].
      getService(Components.interfaces.nsIPrefService);

    var nsIPrefBranchObj = prefService.getBranch(lw_PrefBranchPrefix);
    var prefCount = {value:0}; 
    var prefArray = nsIPrefBranchObj.getChildList("" , prefCount); 

    //linkWrapper_common.debug(prefCount.value);

    var stream = Components.classes['@mozilla.org/network/file-output-stream;1']
                 .createInstance(Components.interfaces.nsIFileOutputStream);
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(linkWrapper_common.myFilePicker)

    fp.init(window, "", fp.modeSave);
    fp.defaultExtension = "txt";
    fp.defaultString = myBrandShortName.toLowerCase() + "_lw_prefs.txt";
    fp.appendFilters(fp.filterText);
    fp.appendFilters(fp.filterAll);

    if (fp.show() == fp.returnCancel)
      return;

    var str = ""

    prefArray.sort();

    for (var i = 0; i < prefArray.length; ++i) {

      switch (nsIPrefBranchObj.getPrefType(prefArray[i])) {
        case nsIPrefBranchObj.PREF_STRING:  // Text = 32
          str += "nsPreferences.setUnicharPref('" + lw_PrefBranchPrefix + prefArray[i] + "', '";
          //str += nsPreferences.copyUnicharPref(lw_PrefBranchPrefix + prefArray[i]).replace(/\\/g, '\\\\'); 
          tmpString = nsPreferences.copyUnicharPref(lw_PrefBranchPrefix + prefArray[i]); 
          tmpString = tmpString.replace(/\\/g, '\\\\'); 
          tmpString = tmpString.replace(/\'/g, '\\\''); 
          str += tmpString; 
          str += "');";
          break;
        case nsIPrefBranchObj.PREF_INT:  // Integer = 64
          str += "nsPreferences.setIntPref('" + lw_PrefBranchPrefix + prefArray[i] + "', ";
          str += nsPreferences.getIntPref(lw_PrefBranchPrefix + prefArray[i]);
          str += ");";
          break;
        case nsIPrefBranchObj.PREF_BOOL:  // Boolean =128
          str += "nsPreferences.setBoolPref('" + lw_PrefBranchPrefix + prefArray[i] + "', "; 
          str += nsPreferences.getBoolPref(lw_PrefBranchPrefix + prefArray[i]);
          str += ");";
          break;
      }

      str += "\r\n"
    }

    stream.init(fp.file, 0x20|0x02|0x08, 0666, 0);
    stream.write(str, str.length);
    stream.close();
  },
  
  importData: function(bReset) {
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(linkWrapper_common.myFilePicker)

    fp.init(window, "", linkWrapper_common.myFilePicker.modeOpen);
    fp.defaultString = myBrandShortName.toLowerCase() + "_lw_prefs.txt";
    fp.defaultExtension = "txt";
    fp.appendFilters(fp.filterText);
    fp.appendFilters(fp.filterAll);

    var retVal = fp.show()

    if (retVal == linkWrapper_common.myFilePicker.returnOK) {
      var mIOService = Components.classes["@mozilla.org/network/io-service;1"]
                         .getService(Components.interfaces.nsIIOService)
      var mFileProtocolHandler = mIOService.getProtocolHandler("file")
                                   .QueryInterface(Components.interfaces.nsIFileProtocolHandler)
      var mURL = mFileProtocolHandler.newFileURI(fp.file)
                   .QueryInterface(Components.interfaces.nsIURL);

      var loader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
        getService(Components.interfaces.mozIJSSubScriptLoader);
      loader.loadSubScript(mURL.spec);
  
      mySettings.getSettings();
    }

  },
  
  resetToDefault: function() {
    var prefService = Components.classes["@mozilla.org/preferences-service;1"].
      getService(Components.interfaces.nsIPrefService);

    var nsIPrefBranchObj = prefService.getBranch(lw_PrefBranchPrefix);
    var prefCount = {value:0}; 
    var prefArray = nsIPrefBranchObj.getChildList("" , prefCount); 

    var branchService = Components.classes["@mozilla.org/preferences-service;1"]
                                   .getService(Components.interfaces.nsIPrefBranch);

    for (var i = 0; i < prefArray.length; ++i) {
//      linkWrapper_common.debug(lw_PrefBranchPrefix + prefArray[i]);
      if (branchService.prefHasUserValue(lw_PrefBranchPrefix + prefArray[i])) {
         branchService.clearUserPref(lw_PrefBranchPrefix + prefArray[i]);
      }
    } 

    mySettings.getSettings();
  },
  
  resetThisToDefault: function(thisPref) {
    var branchService = Components.classes["@mozilla.org/preferences-service;1"]
                                   .getService(Components.interfaces.nsIPrefBranch);

    if (branchService.prefHasUserValue(lw_PrefBranchPrefix + thisPref)) {
       branchService.clearUserPref(lw_PrefBranchPrefix + thisPref);
    }

    mySettings.getSettings();
  }
  
};
/* used for debugging only*/
var mConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService)

function to_console(msg) {
  mConsoleService.logStringMessage("link_wrapper: " + msg);
} 